import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkWechatBill, ThinkWechatBillParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询微信订单表-对账用
 */
export async function pageThinkWechatBill(params: ThinkWechatBillParam) {
  const res = await request.get<ApiResult<PageResult<ThinkWechatBill>>>(
    THINK_API_URL + '/think/think-wechat-bill/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询微信订单表-对账用列表
 */
export async function listThinkWechatBill(params?: ThinkWechatBillParam) {
  const res = await request.get<ApiResult<ThinkWechatBill[]>>(
    THINK_API_URL + '/think/think-wechat-bill',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加微信订单表-对账用
 */
export async function addThinkWechatBill(data: ThinkWechatBill) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改微信订单表-对账用
 */
export async function updateThinkWechatBill(data: ThinkWechatBill) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除微信订单表-对账用
 */
export async function removeThinkWechatBill(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除微信订单表-对账用
 */
export async function removeBatchThinkWechatBill(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-wechat-bill/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询微信订单表-对账用
 */
export async function getThinkWechatBill(id: number) {
  const res = await request.get<ApiResult<ThinkWechatBill>>(
    THINK_API_URL + '/think/think-wechat-bill/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
